MODULE Basics
!-----------------------------------------------------------------------------!
! Description  : Several numerical values, including the KINDs of             !
!                NAG f90/FTN90.                                               !
!                                                                             !
! Author       : Peter Thomas                                                 !
! Last modified: 23/11/93                                                     !
!-----------------------------------------------------------------------------!



! INTEGER-Kinds
  INTEGER, PARAMETER :: INT8    =  SELECTED_INT_KIND(2)
  INTEGER, PARAMETER :: INT16   =  SELECTED_INT_KIND(4)
  INTEGER, PARAMETER :: INT32   =  SELECTED_INT_KIND(9)
  INTEGER, PARAMETER :: INT64   =  SELECTED_INT_KIND(18)

! LOGICAL-Kinds
  INTEGER, PARAMETER :: BYTE    =  INT8
  INTEGER, PARAMETER :: WORD    =  KIND(.FALSE.)

! REAL-Kinds
  INTEGER, PARAMETER :: SINGLE  =  SELECTED_REAL_KIND(4)
  INTEGER, PARAMETER :: DOUBLE  =  SELECTED_REAL_KIND(14)
  INTEGER, PARAMETER :: QUAD    =  SELECTED_REAL_KIND(18)

! COMPLEX-Kinds
  INTEGER, PARAMETER :: CMPLX16  =  SINGLE
  INTEGER, PARAMETER :: CMPLX32  =  DOUBLE
  INTEGER, PARAMETER :: CMPLX64  =  QUAD


#ifdef bit64
  INTEGER, PARAMETER :: myint = INT64
#else
  INTEGER, PARAMETER :: myint = INT32
#endif
  INTEGER, PARAMETER :: myreal = DOUBLE
  INTEGER, PARAMETER :: myreal4 = SINGLE


END MODULE Basics
